<?php if (isset($effects) && $effects) {
    $cr_effect = ' cr-animate-gen"  data-gen="' . $effects . '" data-gen-offset="bottom-in-view';
} else {
    $cr_effect = '';
} ?>

<div class="module module_posts <?php echo $css ?>">

	<?php if ($main_title != ''): ?>
		<h3 class="widget-title">
			<?php if($icon_title): ?>
				<i class="<?php echo $icon_title ?>"></i>
			<?php endif; ?>

			<?php echo $main_title ?>
		</h3>
	<?php endif; ?>

    <div class="blog-posts">

        <?php $options = get_option('second-touch');
        $image_crop = $options['thumb_image_crop'];
        if ($image_crop == "") {
            $image_crop = true;
        }
        ?>

        <?php if ($categories) {
            $args = array(
                'category__in' => explode(',', $categories),
                'posts_per_page' => $no_of_posts,
                'ignore_sticky_posts' => 'true'
            );
        } else {
            $args = array(
                'posts_per_page' => $no_of_posts,
                'ignore_sticky_posts' => 'true'
            );
        }

        $the_query = new WP_Query($args);

        while ($the_query->have_posts()) : $the_query->the_post(); ?>


			<?php // get post format and display template for that format
            //if ( !get_post_format() ) : get_template_part('post-formats/format', 'standard');
            //else : get_template_part('post-formats/format', get_post_format()); endif; ?>


			<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

				<div class="entry-body ovh">

					<header class="entry-header">

						<?php

						if ( $info_box_type == 'avatar' ) {
							$date = get_avatar(get_the_author_meta('ID'), apply_filters('reactor_status_avatar', '70'));
						}elseif($info_box_type == 'date_avatar'){
							$date = get_avatar(get_the_author_meta('ID'), apply_filters('reactor_status_avatar', '70'));

							$date .= sprintf(
								'<time class="entry-date styled updated"style="top: 0" datetime="%1$s" pubdate>%2$s</time>',
								esc_attr( get_the_date( 'c' ) ),
								'<span class="day"> ' . get_the_date( 'd' ) . '</span><span class="mounth">' . get_the_date( 'M' ) . '</span><span class="year">' . get_the_date( 'Y' ) . '</span>'
							);
						} else {
							$date = sprintf(
								'<time class="entry-date styled updated" datetime="%1$s" pubdate>%2$s</time>',
								esc_attr( get_the_date( 'c' ) ),
								'<span class="day"> ' . get_the_date( 'd' ) . '</span><span class="mounth">' . get_the_date( 'M' ) . '</span><span class="year">' . get_the_date( 'Y' ) . '</span>'
							);
						}

						if ( $show_meta == '1' ) {
							echo '<div class="entry-meta">';

							if ( $show_data == '1' ) {
								echo($date);
							}
							$author = sprintf(
								'<span class="author"><a class="url fn n" href="%1$s" title="%2$s" rel="author">%3$s</a></span>',
								esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ),
								esc_attr( sprintf( __( 'View all posts by %s', 'crum' ), get_the_author() ) ),
								get_the_author()
							);
							_e( 'by '. $author, 'crum' ) ;

							$count = 0;
							$categories_list = '';
							$categories = get_the_category();
							foreach ( $categories as $category ) {
								$count ++;
								if ( $category->slug != 'uncategorized' || $category->name != 'Uncategorized' ) {
									$categories_list .= '<a href="' . get_category_link( $category->term_id ) . '" title="' . sprintf( __( 'View all posts in %s', 'crum' ), $category->name ) . '">' . $category->name . '</a>';
									if ( $count != count( $categories ) ) {
										$categories_list .= ', ';
									}
								}
							}
							_e( ' in '. $categories_list, 'crum' ) ;

							$tag_list = get_the_tag_list( '', ', ', '' );
							echo '<div class="entry-tags">';
							_e( 'Tags '. $tag_list, 'crum' ) ;
							echo '</div>';

							echo '</div>';
						}elseif($show_data == '1'){
							echo($date);
						}?>

						<h3 class="entry-title"><a href="<?php the_permalink(); ?>" rel="bookmark" title="<?php the_title_attribute(); ?>"><?php the_title(); ?></a></h3>


						<?php if ( $thumbnail == '1' && has_post_thumbnail()  ) : ?>
						<div class="entry-thumbnail">
								<a href="<?php the_permalink(); ?>" rel="bookmark" title="<?php the_title_attribute(); ?>"><?php the_post_thumbnail('thumb-blog-custom'); ?></a>
						</div>
						<?php endif;?>

					</header><!-- .entry-header -->

						<div class="entry-content">

							<?php

								if ( $excerpt == '1' ) {
									content($excerpt_length);
								}


							?>
						</div><!-- .entry-content -->
					<footer class="entry-footer">
						<?php reactor_post_footer(); ?>
					</footer><!-- .entry-footer -->
				</div><!-- .entry-body -->
			</article><!-- #post -->

        <?php endwhile; ?>

    </div>

    <?php wp_reset_query() ?>

</div>