<?php if ($effects) {
	$cr_effect = ' cr-animate-gen"  data-gen="' . $effects . '" data-gen-offset="bottom-in-view';
} else {
	$cr_effect = '';
}?>

<?php // get the options
$quicksand = ('jquery');
$taxonomy = 'product_cat';
$number_posts = $number_items ? $number_items : '9';
$categories = $categories ? $categories : false;
$show_title = $show_title ? $show_title : false;
$show_meta = $show_meta ? $show_meta : false;

$thumb_style = $thumb_size ? $thumb_size : 'metro';
$uniqid = uniqid( 'crum_recent_shop' );

$prod_size = '';
$count = '0';
?>

<div class="module recent-block <?php echo $cr_effect; ?> <?php echo $css; ?>">

<?php if ($main_title != ''): ?>
	<h3 class="widget-title">
		<?php if($icon_title): ?>
			<i class="<?php echo $icon_title ?>"></i>
		<?php endif; ?>

		<?php echo $main_title ?>
	</h3>
<?php endif; ?>

    <div id="<?php echo $uniqid; ?>-wrap">
<?php
if ( $categories ) {
	$custom_categories = explode( ',', $categories );
	foreach ( $custom_categories as $cust_cat ) {
		$res_cat[] = get_term_by( 'id', (int) $cust_cat, $taxonomy );
	}
}
?>

	<?php // category submenu function
	if (current_theme_supports('reactor-taxonomy-subnav')) {
		reactor_category_submenu(array('taxonomy' => 'product_cat', 'quicksand' => $quicksand, 'terms_args' => $res_cat));
	}

	if ($categories) {
		$product_custom_query = array(
			'tax_query' => array(
				array(
					'taxonomy' => $taxonomy,
					'field' => 'id',
					'terms' => explode(',',$categories)
				)
			));
	} else {
		$product_custom_query = array();
	}

	$args = array(
		'post_type' => 'product',
		'posts_per_page' => $number_posts,

	);

	$args = array_merge($args, $product_custom_query);


	global $product_query;
	$product_query = new WP_Query($args); ?>


	<?php if ($product_query->have_posts()) : ?>

		<?php reactor_loop_before(); ?>

		<ul id="<?php echo $uniqid; ?>" class="filterable-grid works-list bricks">

			<?php while ($product_query->have_posts()) :  $product_query->the_post(); ?>

				<?php // get the categories for data-type storting
				$prod_cats = '';
				$the_id = get_the_ID();
				$the_terms = get_the_terms($the_id, $taxonomy);

				if (($count % 2) == 1) {
					$item_class_count = 'odd';
				} else {
					$item_class_count = 'even';
				}
				if ($the_terms && !is_wp_error($the_terms)) :
					$cat_array = array();

					foreach ($the_terms as $the_term) {
						$cat_array[] = $the_term->slug;
					}
					$prod_cats = join(' ', $cat_array);
				endif;


				$content = get_the_excerpt();
				if (!$content) {
					$content = get_the_content();
				}

				/* Item size grid*/
				if (($count % 3) == 0) {
					$prod_size = 'large';
					$trimmed_content = wp_trim_words(strip_shortcodes($content), '20', '');
				} else {
					$prod_size = 'small';
					$trimmed_content = wp_trim_words(strip_shortcodes($content), '10', '');
				}

				if ( !($thumb_style == 'metro') ) {
					if($thumb_style == 'small'){
						$prod_size = 'small';
						$trimmed_content = wp_trim_words(strip_shortcodes($content), '10', '');
					}elseif($thumb_style == 'large'){
						$prod_size = 'large';
						$trimmed_content = wp_trim_words(strip_shortcodes($content), '20', '');
					}
				}

				/* Item images*/
				if (has_post_thumbnail()) {
					$thumb = get_post_thumbnail_id();
					$img_url = wp_get_attachment_url($thumb, 'full'); //get img URL

                    if ($prod_size == 'large') {
                        $item_class_width = 'large';
                        $article_image = aq_resize($img_url, 416, 200, true); //resize & crop img
                    } else {
                        $item_class_width = 'half';
                        $article_image = aq_resize($img_url, 206, 200, true); //resize & crop img
                    }

				} else {
					echo "no-image";
					if ($prod_size == 'large') {
						$item_class_width = 'large';
						$article_image = get_template_directory_uri() . '/img/no-image-large.jpg';
					} else {
						$item_class_width = 'half';
						$article_image = get_template_directory_uri() . '/img/no-image-half.jpg';
					}
				} ?>

				<?php reactor_post_before(); ?>

				<li class="isotope-item <?php echo $prod_cats . ' ' . $item_class_width . ' ' . $item_class_count; ?>" data-name="<?php the_title(); ?>">

					<article id="post-<?php the_ID(); ?>" class="portfolio">

						<div class="entry-thumbnail">
							<img src="<?php echo $article_image; ?>" alt="<?php the_title(); ?>" title="<?php the_title(); ?>">
						</div>

						<div class="description">
							<?php if ($show_title) : ?>
								<h2 class="entry-title portfolio">
									<?php the_title(); ?>
								</h2>
							<?php endif; ?>
							<?php if ($show_meta) : ?>
								<div class="entry-content">
									<?php  echo $trimmed_content; ?>
								</div>
								<!-- .entry-content -->
							<?php endif; ?>
						</div>
						<!-- .description -->

						<a class="absolute-link" href="<?php echo get_permalink( $the_id ); ?>" rel="bookmark" title="<?php echo get_the_title($the_id); ?>"></a>

					</article>
					<!-- #post -->

				</li>

				<?php reactor_post_after(); ?>

				<?php $count++; endwhile; // end of the portfolio loop ?>
		</ul>

	<?php  endif; wp_reset_query();?>
</div>

    <script>
        (function ($) {

            $(document).ready(function () {

                var container = $('#<?php echo $uniqid; ?>');

                container.imagesLoaded(function () {
                    container.isotope({
                        itemSelector: '.isotope-item',
                        layoutMode: 'fitRows'

                    });

                    $('#<?php echo $uniqid; ?>-wrap .filter a').click(function () {
                        var selector = $(this).parent().attr('data-filter');
                        $(this).parent().parent().find('> dd.active').removeClass('active');
                        $(this).parent().addClass('active');

                        container.isotope({
                            filter: selector
                        });

                        return false;
                    });

                });
            });
        })(jQuery);

    </script>

</div>