<?php if ($effects) {
    $cr_effect = ' cr-animate-gen"  data-gen="' . $effects . '" data-gen-offset="bottom-in-view';
} else {
    $cr_effect = '';
}?>

<?php // get the options
$quicksand = ('jquery');
$taxonomy = 'portfolio-category';
$number_posts = $number_items ? $number_items : '9';
$categories = $categories ? $categories : false;
$show_title = $show_title ? $show_title : false;
$show_meta = $show_meta ? $show_meta : false;

$thumb_style = $thumb_size ? $thumb_size : 'metro';
$folio_size = '';
$count = '0';

$uniqid = uniqid( 'crum_recent_folio' );

?>

<div class="module recent-block <?php echo $cr_effect; ?> <?php echo $css; ?>">

    <?php if ($main_title != ''): ?>
        <h3 class="widget-title">
            <?php if($icon_title): ?>
                <i class="<?php echo $icon_title ?>"></i>
            <?php endif; ?>

            <?php echo $main_title ?>
        </h3>
    <?php endif; ?>

	<?php
	if ( $categories ) {
		$custom_categories = explode( ',', $categories );
		foreach ( $custom_categories as $cust_cat ) {
			$res_cat[] = get_term_by( 'id', (int) $cust_cat, $taxonomy );
		}
	}
	?>

    <div id="<?php echo $uniqid; ?>-wrap">

    <?php // category submenu function
    if (current_theme_supports('reactor-taxonomy-subnav')) {
            reactor_category_submenu(array('taxonomy' => 'portfolio-category', 'quicksand' => $quicksand, 'terms_args' => $res_cat));
    }

    if ($categories) {
        $folio_custom_query = array(
            'tax_query' => array(
                array(
                    'taxonomy' => $taxonomy,
                    'field' => 'id',
                    'terms' => explode(',',$categories)
                )
            ));
    } else {
        $folio_custom_query = array();
    }

    $args = array(
        'post_type' => 'portfolio',
        'posts_per_page' => $number_posts,

    );

    $args = array_merge($args, $folio_custom_query);


    global $portfolio_query;
    $portfolio_query = new WP_Query($args); ?>


    <?php if ($portfolio_query->have_posts()) : ?>

    <?php reactor_loop_before(); ?>

    <ul  id="<?php echo $uniqid; ?>" class="filterable-grid works-list bricks">

        <?php while ($portfolio_query->have_posts()) :  $portfolio_query->the_post(); ?>

            <?php // get the categories for data-type storting
            $port_cats = '';
            $the_id = get_the_ID();
            $the_terms = get_the_terms($the_id, $taxonomy);

            if (($count % 2) == 1) {
                $item_class_count = 'odd';
            } else {
                $item_class_count = 'even';
            }

            if ($the_terms && !is_wp_error($the_terms)) :
                $cat_array = array();
                $cat_array[] = 'mix';
                foreach ($the_terms as $the_term) {
                    $cat_array[] = $the_term->slug;
                }
                $port_cats = join(' ', $cat_array);
            endif;


            $content = get_the_excerpt();
            if (!$content) {
                $content = get_the_content();
            }

            /* Item size grid*/
            if (($count % 3) == 0) {
                $folio_size = 'large';
                $trimmed_content = wp_trim_words(strip_shortcodes($content), '20', '');
            } else {
                $folio_size = 'small';
                $trimmed_content = wp_trim_words(strip_shortcodes($content), '10', '');
            }

			if ( !($thumb_style == 'metro') ) {
				if($thumb_style == 'small'){
					$folio_size = 'small';
					$trimmed_content = wp_trim_words(strip_shortcodes($content), '10', '');
				}elseif($thumb_style == 'large'){
					$folio_size = 'large';
					$trimmed_content = wp_trim_words(strip_shortcodes($content), '20', '');
				}
			}

            /* Item images*/
            if (has_post_thumbnail()) {
                $thumb = get_post_thumbnail_id();
                $img_url = wp_get_attachment_url($thumb, 'full'); //get img URL

                if ($folio_size == 'large') {
                    $item_class_width = 'large';
                    $article_image = aq_resize($img_url, 415, 190, true); //resize & crop img
                } else {
                    $item_class_width = 'half';
                    $article_image = aq_resize($img_url, 205, 190, true); //resize & crop img
                }

            } else {
                echo "no-image";
                if ($folio_size == 'large') {
                    $item_class_width = 'large';
                    $article_image = get_template_directory_uri() . '/img/no-image-large.jpg';
                } else {
                    $item_class_width = 'half';
                    $article_image = get_template_directory_uri() . '/img/no-image-half.jpg';
                }
            } ?>

            <?php reactor_post_before(); ?>

            <li class="isotope-item <?php echo $port_cats . ' ' . $item_class_width . ' ' . $item_class_count; ?>" data-name="<?php the_title(); ?>">

                <article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

                    <div class="entry-thumbnail">
                        <img src="<?php echo $article_image; ?>" alt="<?php the_title(); ?>" title="<?php the_title(); ?>">
                    </div>

                    <div class="description">
                        <?php if ($show_title) : ?>
                            <h2 class="entry-title portfolio">
                                <?php the_title(); ?>
                            </h2>

                        <?php endif; ?>
                        <?php if ($show_meta) : ?>
                            <div class="entry-content">
                                <?php  echo $trimmed_content; ?>
                            </div>
                            <!-- .entry-content -->
                        <?php endif; ?>
                    </div>
                    <!-- .description -->

                    <a class="absolute-link" href="<?php the_permalink() ?>" rel="bookmark" title="<?php the_title_attribute(); ?>"></a>

                </article>
                <!-- #post -->

            </li>

            <?php reactor_post_after(); ?>

            <?php $count++; endwhile; wp_reset_query(); // end of the portfolio loop ?>
    </ul>

    <?php endif; ?>
        <script>
            (function ($) {

                $(document).ready(function () {

                    var container = $('#<?php echo $uniqid; ?>');

                    container.imagesLoaded(function () {
                        container.isotope({
                            itemSelector: '.isotope-item',
                            layoutMode: 'fitRows'

                        });

                        $('#<?php echo $uniqid; ?>-wrap .filter a').click(function () {
                            var selector = $(this).parent().attr('data-filter');
                            $(this).parent().parent().find('> dd.active').removeClass('active');
                            $(this).parent().addClass('active');

                            container.isotope({
                                filter: selector
                            });

                            return false;
                        });

                    });
                });
            })(jQuery);

        </script>

    </div>
</div>